/*******************************************************************************
  File: check.cpp
  Copyright (c) 1999 Bleading Edge Software Technologies, Inc.

  This Software is distributed under the open source, free software model.
  Permission to use, modify, and distribute this Software, including
  incorporating it into proprietary software, is granted without fee, 
  provided this copyright notice appear in all copies of the code.
  You are under no obligation to distribute source code which is derived from
  or uses this Software. You may not do anything however, to prevent the 
  continued distribution of this Software under an open source distribution
  model. This includes, but is not limited to, such things as copyrighting
  or claiming authorship of the Software.
  This Software is distributed in the hope that it will be useful, but it is
  provide "as is", WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

//$----------------------------------------------------------------------------|
$Header: $
  Author: Jack W. Reeves

//!----------------------------------------------------------------------------|
Description:

//#----------------------------------------------------------------------------|
Notes:

//%****************************************************************************/
#include "check.h"

// Standard C++ headers
#include <stdexcept>

// Standard C headers
#include <stdio.h>

// The assert_xxx helper function
std::string
make_where_str(const char* file, int lineno)
{
    static char errbuf[256];
    sprintf(errbuf,"file %s [line %1d]", file, lineno);
    return errbuf;
}

//  Helper functions - all just create the appropriate exception and then call
//  'raise'
void
raise_logic_error(const std::string& why, const std::string& where)
{
    raise<std::logic_error>("std::logic_error", why, where);
}

void
raise_domain_error(const std::string& why, const std::string& where)
{
    raise<std::domain_error>("std::domain_error", why, where);
}

void
raise_invalid_argument(const std::string& why, const std::string& where)
{
    raise<std::invalid_argument>("std::invalid_argument", why, where);
}

void
raise_length_error(const std::string& why, const std::string& where)
{
    raise<std::length_error>("std::length_error", why, where);
}

void
raise_out_of_range(const std::string& why, const std::string& where)
{
    raise<std::out_of_range>("std::out_of_range", why, where);
}

void
raise_runtime_error(const std::string& why, const std::string& where)
{
    raise<std::runtime_error>("std::runtime_error", why, where);
}

void
raise_range_error(const std::string& why, const std::string& where)
{
    raise<std::range_error>("std::range_error", why, where);
}

void
raise_overflow_error(const std::string& why, const std::string& where)
{
    raise<std::overflow_error>("std::overflow_error", why, where);
}

void
raise_underflow_error(const std::string& why, const std::string& where)
{
    raise<std::underflow_error>("std::underflow_error", why, where);
}


