/*******************************************************************************
  File: raise.cpp
  Copyright (c) 1999 Bleading Edge Software Technologies, Inc.

  This Software is distributed under the open source, free software model.
  Permission to use, modify, and distribute this Software, including
  incorporating it into proprietary software, is granted without fee, 
  provided this copyright notice appear in all copies of the code.
  You are under no obligation to distribute source code which is derived from
  or uses this Software. You may not do anything however, to prevent the 
  continued distribution of this Software under an open source distribution
  model. This includes, but is not limited to, such things as copyrighting
  or claiming authorship of the Software.
  This Software is distributed in the hope that it will be useful, but it is
  provide "as is", WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

//$----------------------------------------------------------------------------|
$Header: $
  Author: Jack W. Reeves

//!----------------------------------------------------------------------------|
Description:
  Defines the helper function "make_what_str"

//#----------------------------------------------------------------------------|
Notes:

//%****************************************************************************/
#include "raise.h"

// Assert handler stuff
static raise_handler _theRaiseHandler = null;

raise_handler 
set_raise_handler(raise_handler h)
{
    raise_handler old = _theRaiseHandler;
    _theRaiseHandler = h;
    return old;
}


// Make_what_str
//  Creates a string of the form "Exception 'name'('why'): raised in 'where'"
std::string
make_what_str(const std::string& why, const std::string& where)
{
    std::string what("Exception");
    if (not why.empty()) {
        what += " (";
        what += why;
        what += ')';
    }
    what += ':';
    if (not where.empty()) {
        what += " raised in \"";
        what += where;
        what += '"';
    }
    return what;
}

std::string
make_what_str(const std::string& ex,const std::string& why, const std::string& where)
{
    std::string what("Exception");
    if (not ex.empty()) {
        what += ' ' + ex;
    }
    if (not why.empty()) {
        what += " (";
        what += why;
        what += ')';
    }
    what += ':';
    if (not where.empty()) {
        what += " raised in \"";
        what += where;
        what += '"';
    }
    return what;
}
