//
//      quantity_io.hpp
//
//	Copyright (c) 2001 by Michael S. Kenniston.  For the most
//	recent version check www.xnet.com/~msk/quantity.  Permission is granted
//	to use this code without restriction so long as this copyright
//	notice appears in all source files.

//	This code is provided as-is, with no warrantee of correctness.

#ifndef CUJ_QUANTITY_QUANTITY_IO_HPP_MSK20010708
#define CUJ_QUANTITY_QUANTITY_IO_HPP_MSK20010708

#include <iostream>
#include "cuj/quantity/quantity.hpp"

namespace cuj {
namespace quantity {
namespace detail {

	// Print SI units-and-exponents in as close to NIST-specified format as possible with plain ascii.

	inline void show_dim( std::ostream & os, const char * label, int exp )
	{
		if( exp == 0 )
			return;
		os << " " << label;
		if( exp > 1 )
			os << "+";
		if( exp != 1 )
			os << exp;
	}

} // namespace detail

// I/O operators

template< typename Dims >
	inline std::ostream & operator<<( std::ostream & os, const quantity< Dims > & arg )
	{
		os << arg.get( detail::permit() );
		detail::show_dim( os, "m",   Dims::dim1 );
		detail::show_dim( os, "kg",  Dims::dim2 );
		detail::show_dim( os, "s",   Dims::dim3 );
		detail::show_dim( os, "A",   Dims::dim4 );
		detail::show_dim( os, "K",   Dims::dim5 );
		detail::show_dim( os, "mol", Dims::dim6 );
		detail::show_dim( os, "cd",  Dims::dim7 );
		return os;
	}

} // namespace quantity
} // namespace cuj

#endif // CUJ_QUANTITY_QUANTITY_IO_HPP_MSK20010708
