/*
   +------------------------+
   | Cleanup Framework in C |`
   | ~~~~~~~~~~~~~~~~~~~~~~ |`
   | Stephane GRAD          |`
   | (2001)                 |`
   +------------------------+`
    ``````````````````````````

   +---------+
   | Example |
---+---------+------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>

#include "cleanup.h"

void MyFree(void* aPtr)
{
    printf("MyFree (*aPtr=%d)\n", *(int*)aPtr);
    free(aPtr);
}

void Bye(void* aPtr)
{
    printf("Bye!\n");
}

int g(int* pi)
{
    INITCL(1);
    PUSHCL(NULL, Bye);
    printf("*pi=%d\n", *pi);
    return 0;
    DONECL();
}

int f()
{
    INITCL(2);
    {
        int* pi;
        int* pj;

        if (!(pi = (int*)malloc(sizeof(int))))
        {
            return -1;
        }
        PUSHCL(pi, MyFree);
        *pi = 5;
        if (!(pj = (int*)malloc(sizeof(int))))
        {
            return -2;
        }
        PUSHCL(pj, MyFree);
        //POPCL(3); // test, underflow
        *pj = 10;
        if (!g(pi))
        {
            return 0;
        }
        return 1;
    }
    DONECL();
}

int main(void)
{
    printf("call f(), res=%d\n", f());
    return 0;
}
